// ImagePanel.java
// Started on June 18th, 2001
// Copyright (c) Virtu Halttunen

//import TheGame.*;
import java.awt.*;
import javax.swing.*;

public class ImagePanel extends JPanel
{
    private Image image;
    private int padding;
    private Color background;
    
    public ImagePanel( Image image, int padding, Color background )
    {
	this.image = image;
	this.padding = padding;
	this.background = background;
	
//	revalidateSize();
    }
    
    public void revalidateSize()
    {
	Dimension mySize = new Dimension( 2*padding+image.getWidth( this ), 2*padding+image.getHeight( this ) );
	setMinimumSize( mySize );
	setPreferredSize( mySize );
	setMaximumSize( mySize );
    }
    
    public Image getImage()
    {
	return image;
    }
    
    public void setImage( Image image )
    {
	this.image = image;
        if( image != null )
        {
            revalidateSize();
        }
	repaint();
    }

    protected void paintComponent( Graphics g )
    {
	super.paintComponent( g );
	System.out.println( "ImagePanel: repaint(), size: " + getWidth() + "," +getHeight() );
	g.setColor( background );
	g.fillRect( 0, 0, getWidth(), getHeight() );
        if( image != null )
        {
            g.drawImage( image, padding, padding, background, this );
        }
	else
	{
	    g.setColor( Color.black );
	    g.fillRect( 0, 0, getWidth(), getHeight() );
	}
    }
    
    public void setSize( int width, int height )
    {
	Dimension mySize = new Dimension( width, height );
	setMinimumSize( mySize );
	setPreferredSize( mySize );
	setMaximumSize( mySize );
    }
}