// ImageCropper.java
// Started on June 20th, 2001
// Copyright (c) Virtu Halttunen

import TheGame.*;
import java.awt.*;
import java.awt.image.*;
import javax.swing.JPanel;
import javax.swing.ImageIcon;
import java.util.Vector;
import java.net.URL;

public class ImageCropper
{
    private static final int ERROR_RETRIES = 5;
    private static Component dummy = new JPanel();
    
    public static void cropImage( URL setFileURL, Vector vector, int cellSize )
    {
        Image theSetImage = null;
        int tries = 0;
        boolean errors;
        do
        {
            errors = false;
            try
            {
                theSetImage = new ImageIcon( setFileURL ).getImage(); // Uses ImageIcon to really load the image instead of waiting for the first repaint
            }
            catch( Exception e )
            {
                System.out.println( "ImageCropper: Error loading image! " + e.toString() );
                tries++;
                errors = true;
            }
        } while( errors && tries < ERROR_RETRIES );
        if( errors )
        {
            System.out.println( "Could not load image in " + tries + " attempts, giving up!" );
            System.exit( 0 );
        }
        BufferedImage theImage;
	if( ( theSetImage.getWidth( dummy ) % cellSize == 0 ) && ( theSetImage.getHeight( dummy ) % cellSize == 0 ) )
	{
	    for( int i = 0; i < theSetImage.getHeight( dummy )/cellSize; i++ )
		for( int j = 0; j < theSetImage.getWidth( dummy )/cellSize; j++ )
		{
                    theImage = new BufferedImage( cellSize, cellSize, BufferedImage.TYPE_INT_ARGB_PRE );
                    theImage.getGraphics().drawImage( theSetImage, -j*cellSize, -i*cellSize, dummy );
		    vector.addElement( theImage );
		}
	}
	    System.out.println( "ImageCropper: Cropped image " + setFileURL +", " + vector.size() + " images found" );
    }
	
	public static Image [][] cropImage( URL setFileURL, int xImages, int cellSize )
	{
	    Vector vector = new Vector();
	    cropImage( setFileURL, vector, cellSize );
	    Image [][] images = new Image[ vector.size()/xImages ][ xImages ];
	    int index=0;
	    for( int i = 0; i < vector.size()/xImages; i++ )
	    {
		for( int j = 0; i < xImages; j++ )
		{
		    images[ i ][ j ] = (Image)vector.elementAt( index++ );
		}
	    }
	    return images;
	}
	
	public static void setObserver( Component observer )
	{
	    dummy = observer;
	}
	
}