// AboutDialog.java
// Started on June 16th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.URL;
import java.io.*;

public class AboutDialog extends JFrame implements ActionListener
{
    private static AboutDialog me = null;	// Whee, it's a singleton
    private static String version = "";
    private JButton okButton;
    private JLabel versionLabel;
    
    public AboutDialog()
    {
	try
	{
	    String tempPath = getClass().getResource( "AboutDialog.class" ).toString();
	    String versionPath = tempPath.substring( 0, tempPath.lastIndexOf( "!" )+2 ) + "version";
	    URL versionUrl = new URL( versionPath );
	    BufferedReader versionReader = new BufferedReader( new InputStreamReader( versionUrl.openStream() ) );
	    version = versionReader.readLine();
	}
	catch( Exception ex )
	{
	    System.out.println( "Error loading version!" );
	    ex.printStackTrace();
	    version = "undefined";
	}
	System.out.println( "Version: " + version );
	
	Box top = Box.createVerticalBox();
	JPanel temp;
	temp = new JPanel();
	temp.add( new JLabel( "TheGame" ) );
	top.add( temp );
	temp = new JPanel();
	temp.add( new JLabel( new ImageIcon( ResourceManager.loadImage( "Fubar.png" ) ) ) );
	top.add( temp );
	temp = new JPanel();
	versionLabel = new JLabel( "Version " + version );
	temp.add( versionLabel );
	top.add( temp );
	temp = new JPanel();
	temp.add( new JLabel( "Copyright (c) 2001-2006" ) );
	top.add( temp );
	temp = new JPanel();
	temp.add( new JLabel( "by Virtu Halttunen" ) );
	top.add( temp );
	temp = new JPanel();
	okButton = new JButton( "Ok" );
	okButton.addActionListener( this );
	temp.add( okButton );
	top.add( temp );
	getContentPane().add( top );
	pack();
	getRootPane().setDefaultButton( okButton );
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	int xLoc = (screenSize.width-getWidth())/2;
	int yLoc = (int)((screenSize.height-getHeight())*0.25);
	setLocation( xLoc, yLoc );
	me = this;
    }
    
    public static void showAboutDialog()
    {
	if( me == null )
	{
	    me = new AboutDialog();   
	}
	me.setVisible( true );
    }
    
    public static String getVersion()
    {
	return version;
    }

    public void actionPerformed( ActionEvent e )
    {
        if( e.getSource() == okButton )
        {
            setVisible( false );
        }
    }
}