// AutoCannon.java
// Started on August 12th, 2005
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;

public class AutoCannon extends Weapon
{
    private String [] firingModes = { "Normal" };
    private static Image icon = null;
    
    public static final int COST = 8;
    
    
    public AutoCannon()
    {
        if( icon == null )
        {
            icon = ResourceManager.loadImage( "WeaponGraphics/SmartGunIcon.png" );
        }
    }
    
    public int getDamage()
    {
        return (int)(Math.random()*8)+3;
    }
    
    public int getDamage( boolean critical )
    {
        if( critical )
            return 10;
        return getDamage();
    }
    
    public int getDamage( int range, boolean critical )
    {
        int damage;
        if( critical )
            damage = 10;
        else
            damage = getDamage();
        if( range > 20 )
        {
            damage -= (range-8)/3;
        }
        if( damage <= 0 )
            damage = 1;
        return damage;
    }
    
    public int getActionsToFire()
    {
        return 3;
    }
    
    public int getMovementCost()
    {
        return 3;
    }    
    
    public int getCost()
    {
        return COST;
    }
    
    
    public boolean hasAreaEffect()
    {
        return false;
    }
    
    public String getName()
    {
        return "Auto-cannon";
    }
    
    public Point [] getArea( Game theGame, Point fireFrom, Point fireTo )
    {
        Point [] area = new Point[1];
        area[0]=fireTo;
        return area;
    }
    
    public String [] getFiringModeNames()
    {
        return firingModes;
    }
    
    public int getNumberOfFiringModes()
    {
        return 1;
    }
    
    public int getFiringMode()
    {
        return 0;
    }
    
    public void setFiringMode( int mode )
    {
    }
    
    public int getRequiredAttribute()
    {
        return Marine.HEAVY_WEAPONS;
    }
    
    public Image getIcon()
    {
        return icon;
    }
}