// BobBQueObjective.java
// Started on March 2nd, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;
import java.io.*;

public class BobBQueObjective extends Objective
{
    private final String [] targetTypes = { "terrorists", "dangerous political dissidents", "replicants", "spammers", "peelos" };
    
    protected Game activeGame;
    private int BOBS = 10;
    private int alive = BOBS;
    private int bobCount = 0;
    Character [] bobs; 
    private String target = "or so as yet undisclosed targets";

    public void setGame( Game game )
    {
        activeGame = game;
        Bob bob;
        Point bStart;
        BOBS = 7+(int)(Math.random()*8);
        bobs = new Character[ BOBS ];
        for( int b = 0; b < BOBS; b++ )
        {
            bob = new Bob();
            bob.setGame( activeGame );
            bob.setTraitor();
            bob.setBehavior( Bob.AVOID );
            bStart = activeGame.getRandomPointForMonster();
            bob.setLocation( bStart );
            activeGame.addMonster( bob );
            bobs[ b ] = bob;
        }
        target = targetTypes[ (int)(Math.random()*targetTypes.length) ];
    }

    public boolean isCompleted()
    {
        Character character;
        for( int b = 0; b < bobs.length; b++ )
        {
            character = bobs[ b ];
            if( character.isAlive() )
            {
                return false;
            }
        }
        return true;
    }

    public String getDescriptionClip()
    {
	return BOBS + " " + target;
    }
    
    public String [] getPropertyNames()
    {
        return null;
    }

    public String getProperty( String key )
    {
        return null;
    }

    public void setProperty( String key, String value ) throws IllegalArgumentException
    {}
        
}