// BomberBruteParty.java
// Started on March 2nd, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;
import java.io.*;

/**
 * Adds a small party of BomberBrutes in the game.
 * They hand around, drinking beer and telling manly jokes
 * to each other, until the player comes in, and inevitably
 * spoils their fun.
 * Indicentally, all these Brutes are called "Bob".
 */
public class BomberBruteParty extends Objective
{
    private int foo;
    
    public void setGame( Game game )
    {
        activeGame = game;
        Point start = new Point( 0, 0 );
        boolean foundIt = false;
        // Let's try to find enough space for our little party (5x5 spaces). 50 tries max
        for( int i=0; i < 50; i++ )
        {
            start = game.getRandomPointForMonster();
            if( seekSpace( start ) )
            {
                foundIt=true;
                break;
            }
        }
        if( foundIt )
        {
            addBob( start.x, start.y, Map.EAST );
            addBob( start.x, start.y+1, Map.EAST );
            addBob( start.x+1, start.y+2, Map.EAST );
            addBob( start.x+1, start.y+3, Map.EAST );
            addBob( start.x+2, start.y+4, Map.NORTH );
            addBob( start.x+3, start.y+3, Map.WEST );
            addBob( start.x+3, start.y+2, Map.WEST );
            addBob( start.x+4, start.y+1, Map.WEST );
            addBob( start.x+4, start.y, Map.WEST );
            System.out.println( "Added a BomberBrute party" );
        }
    }

    private void addBob( int x, int y, int direction )
    {
        BomberBrute bob = new BomberBrute();
        bob.setGame( activeGame );
        bob.setState( BomberBrute.WAITING );
        bob.setLocation( x, y );
        bob.setDirection( direction );
        activeGame.addMonster( bob );
    }

    private boolean seekSpace( Point start )
    {
        for( int x=start.x; x < start.x+5; x++ )
            for( int y=start.y; y < start.y+5; y++ )
                if( !activeGame.getMap().isPassable( x, y ) )
                    return false;
        return true;
    }

    public String [] getPropertyNames()
    {
        return null;
    }

    public String getProperty( String key )
    {
        return null;
    }

    public void setProperty( String key, String value ) throws IllegalArgumentException
    {}
    
    
}