// BrainRobotSprite.java
// Started on September 16th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;


public class BrainRobotSprite extends CharacterSprite
{

    private static Image [][] images = null;
    private int corpseDirection = -1;

    public BrainRobotSprite()
    {
        if( images == null )
        {
            images = new Image[2][9];
            Vector temp = new Vector();
            ResourceManager.cropImage( "BrainRobot.png", temp, 96 );
            // Movement sprites
            images[0][ Map.NORTH ] = (Image)temp.elementAt( 1 );
            images[0][ Map.NORTH_WEST ] = (Image)temp.elementAt( 0 );
            images[0][ Map.NORTH_EAST ] = (Image)temp.elementAt( 2 );
            images[0][ Map.WEST ] = (Image)temp.elementAt( 3 );
            images[0][ Map.EAST ] = (Image)temp.elementAt( 5 );
            images[0][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 6 );
            images[0][ Map.SOUTH ] = (Image)temp.elementAt( 7 );
            images[0][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 8 );
            images[0][ 8 ] = (Image)temp.elementAt( 4 );
            // Wounded sprites
            images[1][ Map.NORTH ] = (Image)temp.elementAt( 10 );
            images[1][ Map.NORTH_WEST ] = (Image)temp.elementAt( 9 );
            images[1][ Map.NORTH_EAST ] = (Image)temp.elementAt( 11 );
            images[1][ Map.WEST ] = (Image)temp.elementAt( 12 );
            images[1][ Map.EAST ] = (Image)temp.elementAt( 14 );
            images[1][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 15 );
            images[1][ Map.SOUTH ] = (Image)temp.elementAt( 16 );
            images[1][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 17 );
            images[1][ 8 ] = (Image)temp.elementAt( 13 );

        }
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 96, 96 );
        direction = Map.NORTH;
    }

    public Image getSprite( GameAction action )
    {
        if( action instanceof DeadAction )
        {
            if( corpseDirection < 0 )
            {
                corpseDirection = (int)(Math.random()*2);
            }
            return images[ corpseDirection ][ 8 ];
        }
        if( action instanceof WoundAction )
        {
            return images[1][ direction ];
        }
        return images[0][ direction ];
    }

    public Image getSprite()
    {
        if( corpseDirection < 0 )
        {
            corpseDirection = (int)(Math.random()*2);
        }
        return images[ corpseDirection ][8];
    }

    public void setLocation( Point location)
    {
        this.location.x = location.x-24;
        this.location.y = location.y-24;
        bounds.x = location.x;
        bounds.y = location.y;
    }

    public void setLocation( int x, int y )
    {
        location.x = x-24;
        location.y = y-24;
        bounds.x = x-24;
        bounds.y = y-24;
    }
        
}