// CentipedoidObjective.java
// Started on August 24th, 2005
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;
import java.io.*;

public class CentipedoidObjective extends Objective
{
    private Centipedoid head = null;
    private Centipedoid segment1 = null;
    private Centipedoid segment2 = null;
    private Centipedoid segment3 = null;
    private Centipedoid segment4 = null;
    private Centipedoid tail = null;
   
    public void setGame( Game game )
    {
        activeGame = game;
        Point start = new Point( 0, 0 );
        boolean foundIt = false;
        // Let's try to find enough space for our little party (1x5 spaces). 50 tries max
        for( int i=0; i < 50; i++ )
        {
            start = game.getRandomPointForMonster();
            if( seekSpace( start ) )
            {
                foundIt=true;
                break;
            }
        }
        if( foundIt )
        {
	    head = new Centipedoid();
	    head.setLocation( new Point( start.x, start.y ) );
	    head.setDirection( Map.NORTH );
	    segment1 = new Centipedoid();
	    head.setSegment( Centipedoid.HEAD, null, segment1 );
	    segment1.setLocation( new Point( start.x, start.y+1 ) );
	    segment1.setDirection( Map.NORTH );
	    segment2 = new Centipedoid();
	    segment1.setSegment( Centipedoid.SEGMENT, head, segment2 );
	    segment2.setLocation( new Point( start.x, start.y+2 ) );
	    segment2.setDirection( Map.NORTH );
	    segment3 = new Centipedoid();
	    segment2.setSegment( Centipedoid.SEGMENT, segment1, segment3 );
	    segment3.setLocation( new Point( start.x, start.y+3 ) );
	    segment3.setDirection( Map.NORTH );
	    segment4 = new Centipedoid();
	    segment3.setSegment( Centipedoid.SEGMENT, segment2, segment4 );
	    segment4.setLocation( new Point( start.x, start.y+4 ) );
	    segment4.setDirection( Map.NORTH );
	    tail = new Centipedoid();
	    segment4.setSegment( Centipedoid.SEGMENT, segment3, tail );
	    tail.setLocation( new Point( start.x, start.y+5 ) );
	    tail.setDirection( Map.NORTH );
	    tail.setSegment( Centipedoid.TAIL, segment4, null );
	    
	    activeGame.addMonster( head );
	    activeGame.addMonster( segment1 );
	    activeGame.addMonster( segment2 );
	    activeGame.addMonster( segment3 );
	    activeGame.addMonster( segment4 );
	    activeGame.addMonster( tail );

            System.out.println( "Added a Centipedoid" );
        }
    }
        
    /*
    public boolean isCompleted()
    {
	// Fix the centipedoid if necessary
	Point point = head.getLocation();
	int direction = (head.getDirection()+4)%8;
	if( !Map.isNeighbor( head.getLocation(), segment1.getLocation() ) )
	{
	    head.setLocation( Map.getNeighbor( segment1.getLocation(), segment1.getDirection() ) );
	}
	return true;
    }*/
    
    private boolean seekSpace( Point start )
    {
        for( int x=start.x; x < start.x+1; x++ )
            for( int y=start.y; y < start.y+5; y++ )
                if( !activeGame.getMap().isPassable( x, y ) )
                    return false;
        return true;
    }
    
    public String [] getPropertyNames()
    {
        return null;
    }
    
    public String getProperty( String key )
    {
        return null;
    }
    
    public void setProperty( String key, String value ) throws IllegalArgumentException
    {}
    
    
}