// CloneVatSprite.java
// Started on July 2nd, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.ImageIcon;

public class CloneVatSprite extends Sprite
{

    private static Image topImage = null;
    private static Image brokenTopImage = null;
    private static Image bottomImage = null;
    private static Image brokenBottomImage = null;
    private boolean destroyed = false;
    private boolean top = false;
    private CloneVatObjective host;

    public CloneVatSprite( CloneVatObjective host, boolean top )
    {
        this.host = host;
        this.top = top;
        if( topImage == null )
        {
            Vector temp = new Vector();
            ResourceManager.cropImage( "CloneVat.png", temp, 48 );
            topImage = (Image)temp.elementAt( 0 );
            bottomImage = (Image)temp.elementAt( 1 );

            temp = new Vector();
            ResourceManager.cropImage( "CloneVatBroken.png", temp, 48 );
            brokenTopImage = (Image)temp.elementAt( 0 );
            brokenBottomImage = (Image)temp.elementAt( 1 );
            
        }
        location = new Point( -1, -1 );
        bounds = new Rectangle( 0, 0, 48, 48 );
    }

    public void setDirection( int direction )
    {
    }

    public void setDestroyed()
    {
        destroyed = true;
    }

    public Image getSprite( GameAction action )
    {
        return getSprite();
    }

    public Image getSprite()
    {
        if( top )
        {
            if( host.isDestroyed() )
            {
                return brokenTopImage;
            }
            else
            {
                return topImage;
            }
        }
        else
        {
            if( host.isDestroyed() )
            {
                return brokenBottomImage;
            }
            else
            {
                return bottomImage;
            }
            
        }
    }
}