// CyberBruteSprite.java
// Started on June 4th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;

public class CyberBruteSprite extends CharacterSprite
{

    private static Image [][] images = null;

    public CyberBruteSprite()
    {
        if( images == null )
        {
            images = new Image[8][8];
            Vector temp = new Vector();
            ResourceManager.cropImage( "CyberBrute.png", temp, 144 );
	    int index = 0;
	    // Load everything
	    for( int row=0; row < 8; row++ )
	    {
		for( int dir=0; dir < 8; dir++ )
		{
		    images[ row ][ dir ] = (Image)temp.elementAt( index++ );
		}
	    }
        }
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 144, 144 );
        direction = Map.NORTH;
    }

    public Image getSprite( GameAction action )
    {
	if( action instanceof MoveAction )
	{
	    int theFrame = 0;
	    switch( frame )
	    {
		case 1:
		    theFrame = 1;
		    break;
		case 3:
		    theFrame = 2;
		    break;
	    }
	    return images[ theFrame ][ direction ];
	}
        if( action instanceof ShootAction )
        {
            int theFrame=3+(frame%2);
	    
          
            CyberBrute theBrute = (CyberBrute)character;

            // Special handling for special occasions
            if( theBrute.getHealthState() == CyberBrute.LOSING_ROCKET || theBrute.getHealthState() == CyberBrute.FINAL_DEATH )
            {
                theFrame = 6;	// Show it as being wounded
            }
            return images[ theFrame ][ direction ];
        }
        if( action instanceof MeleeAction )
        {
            return images[ 5 ][ direction ];
        }
        if( action instanceof WoundAction )
        {
            return images[ 6 ][ direction ];
        }
        if( action instanceof DeadAction )
        {
            return images[ 7 ][ direction];
        }
        return images[ 0 ][ direction ];

    }

    public Rectangle getVisualBounds()
    {
	return new Rectangle( location.x+24, location.y+24, 96, 96 );
    }        
    
    public void setLocation( Point location)
    {
        this.location.x = location.x-48;
        this.location.y = location.y-48;
        bounds.x = this.location.x;
        bounds.y = this.location.y;
    }

    public void setLocation( int x, int y )
    {
        location.x = x-48;
        location.y = y-48;
        bounds.x = x-48;
        bounds.y = y-48;
    }

    public int getNumberOfWalkFrames()
    {
	return 5;
    }
    
    public int getNumberOfRangedAttackFrames()
    {
        CyberBrute theBrute = (CyberBrute)character;
        if( theBrute.getHealthState() == CyberBrute.ROCKET )
        {
            return 3;
        }
        return 7;
    }
}