// Egg.java
// Started on June 30th, 2001
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;

public class Egg extends Monster
{
    public Egg()
    {
	location = new Point( 0, 0 );
	direction = Map.NORTH;
	alive = true;
	lastAction = new MoveAction( this, location, location );
	maximumActionPoints = 1;
	currentActionPoints = 1;
	maximumHitPoints = 1;
	currentHitPoints = 1;
    }
    
    public GameAction playAction()
    {
	return lastAction;
    }

    public void setLocation( Point point )
    {
        location = new Point( point );
        lastAction = new WaitAction( this, location );
    }
    
    public boolean applyDamage( int damage )
    {
	alive = false;
	lastAction = new DeadAction( this, location );
	return alive;
    }
    
    public boolean isAlive()
    {
	return alive;
    }

    public int getCurrentActionPoints()
    {
	return 1;
    }
    
    public int getMeleeAbility()
    {
	return -10;
    }
    
    public int getSize()
    {
	return 20;
    }

}