// MineSprite.java
// Started on July 6th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.ImageIcon;

public class MineSprite extends CharacterSprite
{

    private static Image [] images = null;
    private Mine myMine = null;

    public MineSprite()
    {
        if( images == null )
        {
            images = new Image[4];
            Vector temp = new Vector();
            ResourceManager.cropImage( "Mine.png", temp, 48 );
            images[ 0 ] = (Image)temp.elementAt( 0 );
            images[ 1 ] = (Image)temp.elementAt( 1 );
            images[ 2 ] = (Image)temp.elementAt( 2 );
            images[ 3 ] = (Image)temp.elementAt( 3 );
        }
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 48, 48 );
        direction = Map.NORTH;
    }

    public void setCharacter( Character character )
    {
        this.character = character;
        if( character instanceof Mine )
        {
            myMine = (Mine)character;
        }
    }

    public boolean isVisible()
    {
	boolean vis = visible;
        if( myMine != null )
        {
	    if( myMine.isAlive() )
	    {
		vis = myMine.isDiscovered();
	    }
        }
        return vis;
    }
        
    public void setVisible( boolean visible )
    {
        this.visible = visible;
    }
    
    
    public Image getSprite( GameAction action )
    {
        if( myMine != null )
        {
            if( myMine.isArmed() && myMine.isSetByPlayer() )
            {
                return images[ 1 ];
            }
            if( myMine.isArmed() && !myMine.isSetByPlayer() )
            {
                return images[ 2 ];
            }
            
        }
        return images[ 0 ];
    }

    public Image getSprite()
    {
        return images[3];
    }

    public int getNumberOfWalkFrames()
    {
        return 1;
    }
}