// RoamerAI.java
// Started on June 22nd, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.util.Vector;
import java.awt.Point;

public class RoamerAI
{
    private int dummy;
    
    public static GameAction roam( Character character, double turnProbability )
    {
        Game game = character.getGame();
        Point location = character.getLocation();
        int direction = character.getDirection();
        Point point = new Point( location );
        boolean valid = true;	// Is the point a valid target
        GameAction action = new MoveAction( character, location, location );

        Point target = game.getMap().getNeighbor( location, direction );
        // If can continue running in the current direction, prefer that (as per probability)
        if( game.getMap().isPassable( target ) && ( Math.random() > turnProbability ) && ( !game.getMap().isBlockedByInhabitant( target, 100-character.getSize(), false ) ) )
        {
            point = game.getMap().getNeighbor( location, direction );
        }
        else
        {
            boolean found = false;
            int tries = 0;
            do
            {
                point.x = location.x + (int)(Math.random()*3)-1;
                point.y = location.y + (int)(Math.random()*3)-1;
                if( game.getMap().isPassable( point ) && ( !game.getMap().isBlockedByInhabitant( point, 100-character.getSize(), false ) ) )
                {
                    found = true;
                }
                if( ++tries >= 10 )
                {
                    found = true;
                    valid = false;
                }
            } while( !found );
        }
        if( !valid )
        {
            //System.out.println( character.getClass().getName() + " staying put" );
	    return new WaitAction( character, new Point( location ) );
        }
        //System.out.println( character.getClass().getName() + " roaming from (" + location.x +","+location.y +") to ("+point.x+","+point.y+")" );
        action = new MoveAction( character, new Point( location ), point );
        return action;
    }

}
    