// ShotgunSprite.java
// Started on March 17th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;
import java.awt.Graphics;
import javax.swing.RepaintManager;
import java.applet.AudioClip;
import java.applet.Applet;

public class ShotgunSprite extends WeaponSprite
{
    private static AudioClip shoot = null;
    private static AudioClip miss = null;
    private Weapon weapon;

    public ShotgunSprite()
    {
        if( shoot == null && GameMapPanel.playSounds )
        {
            shoot = ResourceManager.loadAudioClip( "shotgun.wav" );
            miss = ResourceManager.loadAudioClip( "miss.wav" );
        }
    }

    public void setWeapon( Weapon weapon )
    {
        this.weapon = weapon;
    }

    public boolean affectsLights( )
    {
        return false;
    }

    public void prepareFrame( Point fireFrom, Point fireTo, int frame, GameMapPanel panel )
    {
        int cellSize = panel.getCellSize();
        RepaintManager.currentManager( panel ).addDirtyRegion( panel, fireTo.x*cellSize-cellSize, fireTo.y*cellSize-cellSize, cellSize*3, cellSize*3 );
    }

    public void drawFrame( Graphics g, GameMapPanel host, int frame )
    {

    }

    public int getFrames()
    {
        return 1;
    }

    public AudioClip getFireSoundEffect()
    {
        return shoot;
    }

    public AudioClip getMissSoundEffect()
    {
        return miss;
    }

}