// SlasherSprite.java
// Started on September 1st, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;


public class SlasherSprite extends CharacterSprite
{

    private static Image [][] images = null;
    private int deadDir = -1;

    public SlasherSprite()
    {
        if( images == null )
        {
            images = new Image[3][9];
            Vector temp = new Vector();
            ResourceManager.cropImage( "Slasher.png", temp, 96 );
            // Walk sprites
            images[0][ Map.NORTH ] = (Image)temp.elementAt( 1 );
            images[0][ Map.NORTH_WEST ] = (Image)temp.elementAt( 0 );
            images[0][ Map.NORTH_EAST ] = (Image)temp.elementAt( 2 );
            images[0][ Map.WEST ] = (Image)temp.elementAt( 3 );
            images[0][ Map.EAST ] = (Image)temp.elementAt( 5 );
            images[0][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 6 );
            images[0][ Map.SOUTH ] = (Image)temp.elementAt( 7 );
            images[0][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 8 );
            // Wound sprites
            images[1][ Map.NORTH ] = (Image)temp.elementAt( 10 );
            images[1][ Map.NORTH_WEST ] = (Image)temp.elementAt( 9 );
            images[1][ Map.NORTH_EAST ] = (Image)temp.elementAt( 11 );
            images[1][ Map.WEST ] = (Image)temp.elementAt( 12 );
            images[1][ Map.EAST ] = (Image)temp.elementAt( 14 );
            images[1][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 15 );
            images[1][ Map.SOUTH ] = (Image)temp.elementAt( 16 );
            images[1][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 17 );
            // Attack sprites
            images[2][ Map.NORTH ] = (Image)temp.elementAt( 19 );
            images[2][ Map.NORTH_WEST ] = (Image)temp.elementAt( 18 );
            images[2][ Map.NORTH_EAST ] = (Image)temp.elementAt( 20 );
            images[2][ Map.WEST ] = (Image)temp.elementAt( 21 );
            images[2][ Map.EAST ] = (Image)temp.elementAt( 23 );
            images[2][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 24 );
            images[2][ Map.SOUTH ] = (Image)temp.elementAt( 25 );
            images[2][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 26 );

            // Corpse images
            images[0][ 8 ] = (Image)temp.elementAt( 4 );
            images[1][ 8 ] = (Image)temp.elementAt( 13 );
            images[2][ 8 ] = (Image)temp.elementAt( 22 );
        }
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 96, 96 );
        direction = Map.NORTH;
    }

    public Image getSprite( GameAction action )
    {
        if( action instanceof DeadAction )
        {
            if( deadDir < 0 )
                deadDir = (int)(Math.random()*3);
            return images[deadDir][ 8 ];
        }
        if( action instanceof MeleeAction )
        {
            return images[2][ direction ];
        }
        if( action instanceof WoundAction )
        {
            return images[1][ direction ];
        }
        return images[0][ direction ];
    }

    public Image getSprite()
    {
        if( deadDir < 0 )
            deadDir = (int)(Math.random()*3);
        return images[deadDir][ 8 ];
    }

    public void setLocation( Point location )
    {
        this.location.x = location.x-24;
        this.location.y = location.y-24;
        bounds.x = this.location.x;
        bounds.y = this.location.y;
    }

    public void setLocation( int x, int y )
    {
        location.x = x-24;
        location.y = y-24;
        bounds.x = x-24;
        bounds.y = y-24;
    }

}