// SurvivalObjective.java
// Started on August 11th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;
import java.io.*;
import java.util.Vector;

public class SurvivalObjective extends Objective
{
    int safeTurns = 10;
    int turns = 22;
    int guns = 1;
    int turn = 0;
    int rippers = 3;
    
    public SurvivalObjective()
    {
        guns = (int)(Math.random()*4)+1;
        safeTurns += (int)(Math.random()*10);
        turns += (int)(Math.random()*16);
        rippers += (int)(Math.random()*6);
    }

    public void setGame( Game activeGame )
    {
        this.activeGame = activeGame;
        SentryGun gun;
        Point gStart;
        System.out.println( "Adding " + guns + " sentry guns" );
        for( int i=0; i < guns; i++ )
        {
            gun = new SentryGun();
            gun.setGame( activeGame );
            gStart = activeGame.getRandomPointForMonster();
            gun.setLocation( gStart );
            activeGame.addMonster( gun );
        }
        SentryGunObjective sentryGunObjective = new SentryGunObjective();
        activeGame.addObjective( sentryGunObjective );
    }

    public int getNumberOfSprites()
    {
        return 0;
    }

    public Sprite getSprite( int x, int y)
    {
        return null;
    }

    public String [] getPropertyNames()
    {
        return null;
    }

    public String getProperty( String key )
    {
        return null;
    }

    public void setProperty( String key, String value ) throws IllegalArgumentException
    {
    }

    public boolean isCompleted()
    {
        turn++;
        if( turn == safeTurns )
        {
            activeGame.handleMessage( new Message( null, "Sir! I think I can hear more of them coming in!" ) );
            Objective objective;
            for( int i = 0; i < rippers; i++ )
            {
                objective = new RipperSpawnObjective();
                if( Math.random() < 0.5 )
                {
                    objective.setProperty( RipperSpawnObjective.MONSTER_CLASSNAME_KEY, "Slasher" );
                }
                objective.setGame( activeGame );
                activeGame.addObjective( objective );
            }            
        }
        if( turn >= turns )
        {
            return true;
        }
        return false;
    }

    public int getSize()
    {
        return 0;
    }

    public boolean isLocatedIn( Point point )
    {
        return false;
    }

    public boolean isLocatedIn( int x, int y )
    {
        return isLocatedIn( new Point( x, y ) );
    }

    public boolean isDestructible()
    {
        return false;
    }

    public boolean isShownOnMap()
    {
        return false;
    }

    public boolean handleDamage( Point point, int damage )
    {
        return false;
    }

    public boolean handleAction( GameAction action )
    {
        return false;
    }
}