// TribbleSprite.java
// Started on december 30th, 2001
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;


public class TribbleSprite extends CharacterSprite
{
    
    private static Image [][] images = null;
    private int color = 0;
    private int xOffset = 0;
    private int yOffset =  0;
    
    public TribbleSprite()
    {
        if( images == null )
        {
            images = new Image[7][8];
            Vector temp = new Vector();
            ResourceManager.cropImage( "Tribble.png", temp, 64 );
	    
	    // Just laod the damn images...
	    int index = 0;
	    for( int row=0; row < 7; row++ )
	    {
		for( int direction = 0; direction < 8; direction++ )
		{
		    images[row][ direction ] = (Image)temp.elementAt( index++ );

		}
	    }
	}
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 64, 64 );
        direction = Map.NORTH;
	color = (int)(Math.random()*2);
	xOffset = 5-(int)(Math.random()*11);
	yOffset = 5-(int)(Math.random()*11);
    }
    
    public Image getSprite( GameAction action )
    {
        if( action instanceof DeadAction )
        {
	    return images[ 6 ][ color ];
        }
	if( action instanceof WoundAction )
        {
            return images[ 2+(3)*color ][ direction ];
        }
	if( action instanceof MoveAction )
	{
	    int aFrame=frame%2;
	    return images[ aFrame+color*3 ][ direction ];
	}
        return images[ 0+color*3 ][ direction ];
    }
    
    public Image getSprite()
    {
        return images[ 6 ][ color ];
    }
    
    public int getNumberOfWalkSprites()
    {
	return 5;
    }
    
    public Rectangle getBounds()
    {
	if( ((Tribble)character).isPickedUp() )
	{
	    return new Rectangle( -10, -10, 1, 1 );
	}
	return super.getBounds();
    }
    
    public Rectangle getVisualBounds()
    {
	return new Rectangle( location.x+12-xOffset, location.y+12-yOffset, 48, 48 );
    }
    
    public void setLocation( Point location)
    {
        this.location.x = location.x-12+xOffset;
        this.location.y = location.y-12+yOffset;
        bounds.x = location.x+xOffset;
        bounds.y = location.y+yOffset;
    }
    
    public void setLocation( int x, int y )
    {
        location.x = x-12+xOffset;
        location.y = y-12+yOffset;
        bounds.x = x-12+xOffset;
        bounds.y = y-12+yOffset;
    }
    
}