// VipidiotSprite.java
// Started on August 12th, 2005
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.ImageIcon;

public class VipidiotSprite extends CharacterSprite
{
    
    private static Image [][][] images = null;
    private int deadDir = -1;
    private int type = Vipidiot.PROFESSOR;
    
    public VipidiotSprite()
    {
        if( images == null )
        {
            images = new Image[3][6][8];
	    // Load sprites
            Vector temp = new Vector();
            ResourceManager.cropImage( "Vipidiot.png", temp, 96 );
	    int index = 0;
	    for( int row=0; row < 6; row++ )
	    {
		for( int dir=0; dir < 8; dir++ )
		{
		    images[0][row][ dir ] = (Image)temp.elementAt( index++ );
		}
	    }
	    temp = new Vector();
	    index = 0;
            ResourceManager.cropImage( "Vipidiot2.png", temp, 96 );
	    for( int row=0; row < 6; row++ )
	    {
		for( int dir=0; dir < 8; dir++ )
		{
		    images[1][row][ dir ] = (Image)temp.elementAt( index++ );
		}
	    }
	    temp = new Vector();
	    index = 0;
            ResourceManager.cropImage( "Vipidiot3.png", temp, 96 );
	    for( int row=0; row < 6; row++ )
	    {
		for( int dir=0; dir < 8; dir++ )
		{
		    images[2][row][ dir ] = (Image)temp.elementAt( index++ );
		}
	    }
	    
	}
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 96, 96 );
        direction = Map.NORTH;
    }
    
    public void setCharacter( Character character )
    {
	this.character = character;
	if( character instanceof Vipidiot )
	{
	    type = ((Vipidiot)character).getVipType();
	    System.out.println( "Vipidiot type: " + type );
	}
    }
    
    public Image getSprite( GameAction action )
    {
        if( action instanceof DeadAction )
        {
	    if( deadDir < 0 )
	    {
		if( type == Vipidiot.PROFESSOR )
		{
		    deadDir = (int)(Math.random()*3);
		}
		if( type == Vipidiot.OFFICER )
		{
		    deadDir = (int)(Math.random()*3);
		}
		if( type == Vipidiot.DEMAGOGUE )
		{
		    deadDir = (int)(Math.random()*3);
		}
	    }
	    return images[ type ][ 5 ][ deadDir ];
        }
	if( action instanceof MoveAction )
	{
	    int theFrame = 0;
	    switch( frame )
	    {
		case 1:
		    theFrame = 1;
		    break;
		case 3:
		    theFrame = 2;
		    break;
	    }
	    return images[ type ][ theFrame ][ direction ]; 
	}
	if( action instanceof MeleeAction )
	{
	    int theFrame = 3;
	    switch( frame )
	    {
		case 0:
		case 4:
		    theFrame = 0;
		    break;
	    }
	    return images[ type ][ theFrame ][ direction ];
	}
	if( action instanceof WoundAction )
	{
	    return images[ type ][ 4 ][ direction ];
	}
        return images[ type ][ 0 ][ direction ]; 
    }
    
    public int getNumberOfWalkFrames()
    {
	return 5;
    }
    
    public int getNumberOfMeleeAttackFrames()
    {
	return 5;
    }
    
    public Image getSprite()
    {
	if( deadDir < 0 )
	{
	    if( type == Vipidiot.PROFESSOR )
	    {
		deadDir = (int)(Math.random()*3);
	    }
	    if( type == Vipidiot.OFFICER )
	    {
		deadDir = (int)(Math.random()*3);
	    }
	    if( type == Vipidiot.DEMAGOGUE )
	    {
		deadDir = (int)(Math.random()*3);
	    }
	}
	return images[ type ][ 5 ][ deadDir ];
    }
    
    public Rectangle getBounds()
    {
        return bounds;
    }
    
    public Point getLocation()
    {
        return location;
    }    
    
    public Rectangle getVisualBounds()
    {
	return new Rectangle( location.x+24, location.y+24, 48, 48 );
    }
    
    public void setLocation( Point location)
    {
        this.location.x = location.x-24;
        this.location.y = location.y-24;
        bounds.x = location.x;
        bounds.y = location.y;
    }
    
    public void setLocation( int x, int y )
    {
        location.x = x-24;
        location.y = y-24;
        bounds.x = x-24;
        bounds.y = y-24;
    }
    
    
}