// WeaponSprite.java
// Started on February 25th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;
import java.awt.Graphics;
import javax.swing.RepaintManager;
import java.applet.AudioClip;
import java.applet.Applet;

/**
 * WeaponSprite handles the animation and the sounds of the weapons.
 * Note that one WeaponSprite instance handles all the weapons of the
 * same class.
 */
public abstract class WeaponSprite
{
    public abstract AudioClip getFireSoundEffect();
    public abstract AudioClip getMissSoundEffect();

    /**
     * This method ois called before animating the weapon effect.
     *
     * @param weapon	the weapon to be animated
     */
    public abstract void setWeapon( Weapon weapon );
    
    public boolean affectsLights()
    {
        return false;
    }

    public void prepareFrame( Point fireFrom, Point fireTo, int frame, GameMapPanel panel )
    {
        int cellSize = panel.getCellSize();
        RepaintManager.currentManager( panel ).addDirtyRegion( panel, fireTo.x*cellSize-cellSize, fireTo.y*cellSize-cellSize, cellSize*3, cellSize*3 );
    }
    
    public void drawFrame( Graphics g, GameMapPanel host, int frame )
    {

    }

    public int getFrames()
    {
        return 0;
    }
}